import { HttpClient } from '@angular/common/http';
import { DomSanitizer } from '@angular/platform-browser';
import { marked } from 'marked';
import { Observable } from 'rxjs';
import { DynamicFormMarkdownOptions } from './dynamic-form-markdown-options';
import * as i0 from "@angular/core";
export declare class MarkdownRenderer extends marked.Renderer {
    link(href: string, title: string, text: string): string;
}
export declare class DynamicFormMarkdownService {
    private httpClient;
    private sanitizer;
    constructor(httpClient: HttpClient, sanitizer: DomSanitizer);
    compile(markdown: string, options?: DynamicFormMarkdownOptions): Observable<string>;
    compileFromSource(source: string, options?: DynamicFormMarkdownOptions): Observable<string>;
    private parseMarkdown;
    private getSecurityContext;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicFormMarkdownService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DynamicFormMarkdownService>;
}
